GNU bug report logs - #43219
[PATCH] gnu: Handle nfs-root device strings.

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix-patches; Reported by: Stefan <stefan-guix@HIDDEN>; Keywords: patch; dated Sat, 5 Sep 2020 11:27:01 UTC; Maintainer for guix-patches is guix-patches@HIDDEN.

Message received at 43219 <at> debbugs.gnu.org:


Received: (at 43219) by debbugs.gnu.org; 7 Sep 2020 18:44:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Sep 07 14:44:47 2020
Received: from localhost ([127.0.0.1]:50837 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kFM8F-0002KU-8B
	for submit <at> debbugs.gnu.org; Mon, 07 Sep 2020 14:44:47 -0400
Received: from mx009.vodafonemail.xion.oxcs.net ([153.92.174.39]:18400)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stefan-guix@HIDDEN>) id 1kFM8D-0002KG-CM
 for 43219 <at> debbugs.gnu.org; Mon, 07 Sep 2020 14:44:46 -0400
Received: from vsmx002.vodafonemail.xion.oxcs.net (unknown [192.168.75.192])
 by mta-6-out.mta.xion.oxcs.net (Postfix) with ESMTP id B9E63604D95;
 Mon,  7 Sep 2020 18:44:38 +0000 (UTC)
Received: from macbook-pro.kuh-wiese.my-router.de (unknown [178.5.77.113])
 by mta-6-out.mta.xion.oxcs.net (Postfix) with ESMTPA id 41F53604260;
 Mon,  7 Sep 2020 18:44:34 +0000 (UTC)
Content-Type: text/plain; charset=utf-8
Mime-Version: 1.0 (Mac OS X Mail 9.3 \(3124\))
Subject: Re: [bug#43219] [PATCH] gnu: Handle nfs-root device strings.
From: Stefan <stefan-guix@HIDDEN>
In-Reply-To: <6354A850-CD6B-43EC-8DFA-3B1F172C935B@HIDDEN>
Date: Mon, 7 Sep 2020 20:44:33 +0200
Content-Transfer-Encoding: quoted-printable
Message-Id: <6028D7D4-E880-4E45-8D5B-6FDE196809CD@HIDDEN>
References: <4D0B1280-3FB5-48E5-B985-24773F966618@HIDDEN>
 <20200907110552.0bdef27e@HIDDEN>
 <6354A850-CD6B-43EC-8DFA-3B1F172C935B@HIDDEN>
To: Danny Milosavljevic <dannym@HIDDEN>
X-Mailer: Apple Mail (2.3124)
X-VADE-STATUS: LEGIT
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43219
Cc: 43219 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi Danny!

> However, the grub.cfg is loaded via TFTP as well, so root must be =
preset to =E2=80=98(tftp)=E2=80=99 or even =E2=80=98(http)=E2=80=99 due =
to DHCP options. So omitting the search command could be enough and even =
allow the use of HTTP.
>=20
> It could also be possible to keep the =E2=80=98search =E2=80=94file=E2=80=
=99 command, if it does not produce an error.
>=20
> I=E2=80=99ll check that.=20

I think we should use that change.

+        ((? (lambda (device)
+              (and (string? device) (string-contains device ":/"))) =
nfs-uri)
+         "set root=3D(tftp)")

The point is the following: It is possible that GRUB got loaded from a =
local storage and that the current system is also on a local storage. =
Then the root variable is set to some =E2=80=98(hd0,1)=E2=80=99 or =
similar.

If you then select to boot an older system generation or a custom menu =
entry, which is using TFTP and NFS, then the root variable has to be =
changed to =E2=80=98(tftp)=E2=80=99.


Bye

Stefan




Information forwarded to guix-patches@HIDDEN:
bug#43219; Package guix-patches. Full text available.

Message received at 43219 <at> debbugs.gnu.org:


Received: (at 43219) by debbugs.gnu.org; 7 Sep 2020 13:33:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Sep 07 09:33:09 2020
Received: from localhost ([127.0.0.1]:48422 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kFHGf-0008T3-3Z
	for submit <at> debbugs.gnu.org; Mon, 07 Sep 2020 09:33:09 -0400
Received: from dd26836.kasserver.com ([85.13.145.193]:34046)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <dannym@HIDDEN>) id 1kFHGc-0008Su-Ls
 for 43219 <at> debbugs.gnu.org; Mon, 07 Sep 2020 09:33:07 -0400
Received: from localhost (80-110-126-103.cgn.dynamic.surfer.at
 [80.110.126.103])
 by dd26836.kasserver.com (Postfix) with ESMTPSA id 1AFDC3363916;
 Mon,  7 Sep 2020 15:33:05 +0200 (CEST)
Date: Mon, 7 Sep 2020 15:33:02 +0200
From: Danny Milosavljevic <dannym@HIDDEN>
Subject: Re: [bug#43219] [PATCH] gnu: Handle nfs-root device strings.
Message-ID: <20200907153302.296bdb5a@HIDDEN>
In-Reply-To: <20200907110552.0bdef27e@HIDDEN>
References: <4D0B1280-3FB5-48E5-B985-24773F966618@HIDDEN>
 <20200907110552.0bdef27e@HIDDEN>
X-Mailer: Claws Mail 3.17.5 (GTK+ 2.24.32; x86_64-unknown-linux-gnu)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="Sig_/i8Cp9k3_MggFFRSAEVh9S0.";
 protocol="application/pgp-signature"; micalg=pgp-sha512
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 43219
Cc: Stefan <stefan-guix@HIDDEN>, 43219 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

--Sig_/i8Cp9k3_MggFFRSAEVh9S0.
Content-Type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: quoted-printable

Pushed "nfs-root-fs" system test--with minimal changes--to guix master as
commit a1a39ed5a46044161a71cbe6931c7e3006a82ecb.

--Sig_/i8Cp9k3_MggFFRSAEVh9S0.
Content-Type: application/pgp-signature
Content-Description: OpenPGP digital signature

-----BEGIN PGP SIGNATURE-----

iQEzBAEBCgAdFiEEds7GsXJ0tGXALbPZ5xo1VCwwuqUFAl9WNo4ACgkQ5xo1VCww
uqVI2QgAlXwubeH8YibbZyJOjNLhlsgF9soKyX3Bq66W8sE+sah4bjqIs5mBOXaz
mDahEKJq2vMMoQGdEEQIYEfjvScT88nT4WDENDDvXZhAK+z4HQo8y6Ii/qPCwspG
Zp7r9ZuhKZa0qZOGezQdaY8hoSH0gplCMgGsb9yy1nOc3cZhTWi0x4lUO7kmZ7zV
MSVuyj/Pf1tAOCovDDIlG3JbvhM9ElDu/fytEEFwj+YFMSrQi6cJ6raw9ZWK3akg
1+wOvd8D2ISEUO98vjfVoAzqDza4odI08Rv7WvWjJWLVnDdLXsHG+Ud6bLPpzpJO
XFgvKYA4SwaDy+uiy87QRb1n+BhGKw==
=6iYi
-----END PGP SIGNATURE-----

--Sig_/i8Cp9k3_MggFFRSAEVh9S0.--




Information forwarded to guix-patches@HIDDEN:
bug#43219; Package guix-patches. Full text available.

Message received at 43219 <at> debbugs.gnu.org:


Received: (at 43219) by debbugs.gnu.org; 7 Sep 2020 12:50:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Sep 07 08:50:19 2020
Received: from localhost ([127.0.0.1]:48367 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kFGbD-0007OH-B9
	for submit <at> debbugs.gnu.org; Mon, 07 Sep 2020 08:50:19 -0400
Received: from vsmx011.vodafonemail.xion.oxcs.net ([153.92.174.89]:19412)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stefan-guix@HIDDEN>) id 1kFGbB-0007O3-E0
 for 43219 <at> debbugs.gnu.org; Mon, 07 Sep 2020 08:50:18 -0400
Received: from vsmx003.vodafonemail.xion.oxcs.net (unknown [192.168.75.197])
 by mta-5-out.mta.xion.oxcs.net (Postfix) with ESMTP id 5576259D21B;
 Mon,  7 Sep 2020 12:50:11 +0000 (UTC)
Received: from macbook-pro.kuh-wiese.my-router.de (unknown [178.5.77.113])
 by mta-7-out.mta.xion.oxcs.net (Postfix) with ESMTPA id EB152539A12;
 Mon,  7 Sep 2020 12:50:06 +0000 (UTC)
Content-Type: text/plain; charset=utf-8
Mime-Version: 1.0 (Mac OS X Mail 9.3 \(3124\))
Subject: Re: [bug#43219] [PATCH] gnu: Handle nfs-root device strings.
From: Stefan <stefan-guix@HIDDEN>
In-Reply-To: <20200907110552.0bdef27e@HIDDEN>
Date: Mon, 7 Sep 2020 14:50:05 +0200
Content-Transfer-Encoding: quoted-printable
Message-Id: <6354A850-CD6B-43EC-8DFA-3B1F172C935B@HIDDEN>
References: <4D0B1280-3FB5-48E5-B985-24773F966618@HIDDEN>
 <20200907110552.0bdef27e@HIDDEN>
To: Danny Milosavljevic <dannym@HIDDEN>
X-Mailer: Apple Mail (2.3124)
X-VADE-STATUS: LEGIT
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43219
Cc: 43219 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hi Danny!

>> * gnu/bootloader/grub.scm (grub-root-search): Suppor nfs-root device =
strings to
>> set the root to tftp.
>=20
> Why does having a NFS root "device" imply using TFTP?
>=20
> I can see that it would be nice--but I've been using NFS for many =
years without
> using TFTP.

True.=20

If you use an NFS share as the root file system, it=E2=80=99s just very =
likely that you use a diskless setup.

It is uncommon, that you have some storage device, from which you load =
the kernel and the initrd, but which is not also your root file system =
device. Usually the kernel and the initrd are located in the root file =
system.

But take a closer look at (grub-root-search device file): This function =
gets a device record or device string, which is expected to contain the =
file to look for.

If that device string is an NFS share, then GRUB has only two =
possibilities to access that file: either via TFTP or HTTP. Actually =
there is no way yet to divide between these two possibilities.

GRUB does not support NFS, and the chance that the searched file on the =
NFS share is accessible on a local storage as well is very low.

I chose TFTP over HTTP because of this reasons:

 =E2=80=A2 PXE specifies TFTP but seems not to specify HTTP.
 =E2=80=A2 The =E2=80=98file=E2=80=99 field inside the DHCP header =
implies TFTP.
 =E2=80=A2 For BOOTP/DHCPv4 the RFC 2132 defines a TFTP server for =
option 66.
 =E2=80=A2 U-Boot supports TFTP but not HTTP (important for =
chain-loading).
 =E2=80=A2 The Raspberry Pi only supports TFTP.

Only with DHCPv6 there is RFC 5970, which specifies option 59 to contain =
a boot-file-url, which may start with =E2=80=98http://=E2=80=99 but also =
allows =E2=80=98tftp://=E2=80=99.=20

>> +        ((? (lambda (device)
>> +              (and (string? device) (string-contains device ":/"))) =
nfs-uri)
>> +         "set root=3D(tftp)")
>=20
> What is that required for in practice?

As stated above, (grub-root-search device file) is used to find the =
device from which to load the file. It normally generates a GRUB search =
command to specify inside the root variable where to find that file. =
That the root variable gets set is not obvious from the generated search =
command. But take a look here, it is the default: =
<https://www.gnu.org/software/grub/manual/grub/grub.html#search>.

However, searching for files is not possible via TFTP, so with =E2=80=9Cse=
t root=3D(tftp)=E2=80=9D we specify not to search for the file, but to =
assume that it is accessible via TFTP. Beside a =E2=80=9Cset =
root=3D(http)=E2=80=9D this is the only way to specify the root, if the =
device is an NFS share.

However, the grub.cfg is loaded via TFTP as well, so root must be preset =
to =E2=80=98(tftp)=E2=80=99 or even =E2=80=98(http)=E2=80=99 due to DHCP =
options. So omitting the search command could be enough and even allow =
the use of HTTP.

It could also be possible to keep the =E2=80=98search =E2=80=94file=E2=80=99=
 command, if it does not produce an error.

I=E2=80=99ll check that.=20

> Pushed all the other hunks except for the one above--for now.
>=20
> Guix master commit 1c3b709edb8e6248a9a84dde57b27f3fdc997f21.

Thanks.


Bye

Stefan





Information forwarded to guix-patches@HIDDEN:
bug#43219; Package guix-patches. Full text available.

Message received at 43219 <at> debbugs.gnu.org:


Received: (at 43219) by debbugs.gnu.org; 7 Sep 2020 09:32:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Sep 07 05:32:35 2020
Received: from localhost ([127.0.0.1]:48099 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kFDVr-0006Zw-KJ
	for submit <at> debbugs.gnu.org; Mon, 07 Sep 2020 05:32:35 -0400
Received: from vsmx011.vodafonemail.xion.oxcs.net ([153.92.174.89]:43382)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stefan-guix@HIDDEN>) id 1kFDVp-0006Zh-0A
 for 43219 <at> debbugs.gnu.org; Mon, 07 Sep 2020 05:32:33 -0400
Received: from vsmx003.vodafonemail.xion.oxcs.net (unknown [192.168.75.197])
 by mta-5-out.mta.xion.oxcs.net (Postfix) with ESMTP id 66F0559CF64
 for <43219 <at> debbugs.gnu.org>; Mon,  7 Sep 2020 09:32:26 +0000 (UTC)
Received: from macbook-pro.kuh-wiese.my-router.de (unknown [178.5.77.113])
 by mta-7-out.mta.xion.oxcs.net (Postfix) with ESMTPA id 39AC7539ADD
 for <43219 <at> debbugs.gnu.org>; Mon,  7 Sep 2020 09:32:24 +0000 (UTC)
From: Stefan <stefan-guix@HIDDEN>
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
Subject: Fwd: [PATCH] gnu: Handle nfs-root device strings.
Date: Mon, 7 Sep 2020 11:32:24 +0200
References: <1A001E6C-A2C2-4364-B40D-C88059941CDF@HIDDEN>
To: 43219 <at> debbugs.gnu.org
Message-Id: <0919615E-841A-429D-A61F-720DD7FED43D@HIDDEN>
Mime-Version: 1.0 (Mac OS X Mail 9.3 \(3124\))
X-Mailer: Apple Mail (2.3124)
X-VADE-STATUS: LEGIT
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43219
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


Hi Danny!

> That sounds like a good idea.

I'm glad to hear this. :-)

> First, I like to apologize for the huge delay in handling this stuff.

Nevermind.

> My
> original intent was to let Brice Waegeneire <brice@HIDDEN>, my =
GSoC intern
> for network booting, handle your request--both because he needs it =
anyway and
> because he presumably has more knowledge on network booting.  He's =
missing in
> action (no communication at all) and I gave up having Brice do it.
> In any case, his GSoC is over.

That=E2=80=99s a pity.

> I will now look at your request on my own.  I obtained some Raspberry =
Pis, a
> NAS with TFTP server support out of the box and I made sure I could =
manipulate
> the DHCP server I use on my network, so the next step is to try to =
actually
> use your patchset myself--which I didn't do before (sorry).
>=20
> I want to note that patches with system tests are processed *much* =
faster--I
> don't think many reviewers would go to those lengths I did (obtaining =
special
> hardware) in order to test contributions--so usually, it would have =
been
> basically stuck forever without system tests.

Oh, I would never have expected that. I tried to do a system test, but =
for aarch64 substitutes where missing (I think basically qemu) and =
building locally on my small system took days and failed in the end, so =
I gave up. But please take a look here, it may help: =
<https://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D41820#17>

> Thanks for persevering on this feature.

Sure, its in my own interest. :-)

>> However, that <nfs-share> record would brake with the compatibility =
of how an
>> NFS mount is defined today, and it makes the code much more complex =
without
>> having a real gain.
>=20
> The real gain would be this:
>=20
> There are a lot of options that one could need (see
> https://www.kernel.org/doc/Documentation/filesystems/nfs/nfsroot.txt .

> I'm just saying that it will become a record over time anyway.  But =
maybe
> it will be something more general for PXE--hard to tell which is =
better at
> this point in time.   So nevermind for now.

I know about them and used them before. I agree, a bigger record makes =
sense. But please consider that these options actually disable the use =
of an initrd, which brings more complications, as guix currently relies =
on having an initrd.

> However, I cannot see a patch as attachment to your E-Mail.

Oh, that was just my initial e-mail generating this ticket yesterday: =
<https://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D43219#5>


Bye

Stefan





Information forwarded to guix-patches@HIDDEN:
bug#43219; Package guix-patches. Full text available.

Message received at 43219 <at> debbugs.gnu.org:


Received: (at 43219) by debbugs.gnu.org; 7 Sep 2020 09:05:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Sep 07 05:05:57 2020
Received: from localhost ([127.0.0.1]:48074 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kFD65-0005vH-B7
	for submit <at> debbugs.gnu.org; Mon, 07 Sep 2020 05:05:57 -0400
Received: from dd26836.kasserver.com ([85.13.145.193]:39158)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <dannym@HIDDEN>) id 1kFD62-0005v6-Um
 for 43219 <at> debbugs.gnu.org; Mon, 07 Sep 2020 05:05:55 -0400
Received: from localhost (80-110-126-103.cgn.dynamic.surfer.at
 [80.110.126.103])
 by dd26836.kasserver.com (Postfix) with ESMTPSA id 4942833639CD;
 Mon,  7 Sep 2020 11:05:53 +0200 (CEST)
Date: Mon, 7 Sep 2020 11:05:52 +0200
From: Danny Milosavljevic <dannym@HIDDEN>
To: Stefan <stefan-guix@HIDDEN>
Subject: Re: [bug#43219] [PATCH] gnu: Handle nfs-root device strings.
Message-ID: <20200907110552.0bdef27e@HIDDEN>
In-Reply-To: <4D0B1280-3FB5-48E5-B985-24773F966618@HIDDEN>
References: <4D0B1280-3FB5-48E5-B985-24773F966618@HIDDEN>
X-Mailer: Claws Mail 3.17.5 (GTK+ 2.24.32; x86_64-unknown-linux-gnu)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="Sig_/li7w50WUGyJ5X+Cs5zDy7ig";
 protocol="application/pgp-signature"; micalg=pgp-sha512
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43219
Cc: 43219 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--Sig_/li7w50WUGyJ5X+Cs5zDy7ig
Content-Type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: quoted-printable

Hi Stefan,

On Sat, 5 Sep 2020 13:26:25 +0200
Stefan <stefan-guix@HIDDEN> wrote:

> * gnu/bootloader/grub.scm (grub-root-search): Suppor nfs-root device stri=
ngs to
> set the root to tftp.

Why does having a NFS root "device" imply using TFTP?

I can see that it would be nice--but I've been using NFS for many years wit=
hout
using TFTP.

> +        ((? (lambda (device)
> +              (and (string? device) (string-contains device ":/"))) nfs-=
uri)
> +         "set root=3D(tftp)")

What is that required for in practice?

Pushed all the other hunks except for the one above--for now.

Guix master commit 1c3b709edb8e6248a9a84dde57b27f3fdc997f21.

--Sig_/li7w50WUGyJ5X+Cs5zDy7ig
Content-Type: application/pgp-signature
Content-Description: OpenPGP digital signature

-----BEGIN PGP SIGNATURE-----

iQEzBAEBCgAdFiEEds7GsXJ0tGXALbPZ5xo1VCwwuqUFAl9V9/AACgkQ5xo1VCww
uqWdMQf+KppdbwedX35/ZxH7VZgLb5kUyKRYlj7lNiOur1vEQAO0bJUH7mp9DkV0
byO5TPo15TyEMJMjTqLTkIIYcpzaKxhJ4L5CaPnmipv5mAlfXNPIkhaLW3oGzCIa
XlE35SF3mt4otkMjpo2NmmBRsKNLtHHbEX9+aUVtpesZyKUEqjjeoSGNtwG2ybvB
ChPph688mBGyHGy9wuRxbL3yjlYpTjDbsHEg5B13wqal0u52Y8qiXoMPMm5hGlO4
QvFmqOf15olUQOgQ2jOzsUUs5lwoAPtEw8zDw5Mw60UvaN2jDD2ta0Yvevf5g+qZ
J+uH3FSAPKog2VVoFu5epqaszEU5AQ==
=5k/g
-----END PGP SIGNATURE-----

--Sig_/li7w50WUGyJ5X+Cs5zDy7ig--




Information forwarded to guix-patches@HIDDEN:
bug#43219; Package guix-patches. Full text available.

Message received at 43219 <at> debbugs.gnu.org:


Received: (at 43219) by debbugs.gnu.org; 6 Sep 2020 12:21:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 06 08:21:26 2020
Received: from localhost ([127.0.0.1]:44962 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kEtfi-0001p8-3q
	for submit <at> debbugs.gnu.org; Sun, 06 Sep 2020 08:21:26 -0400
Received: from dd26836.kasserver.com ([85.13.145.193]:59620)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <dannym@HIDDEN>) id 1kEtff-0001oy-4c
 for 43219 <at> debbugs.gnu.org; Sun, 06 Sep 2020 08:21:25 -0400
Received: from localhost (80-110-126-103.cgn.dynamic.surfer.at
 [80.110.126.103])
 by dd26836.kasserver.com (Postfix) with ESMTPSA id A43ED3360BBD;
 Sun,  6 Sep 2020 14:21:20 +0200 (CEST)
Date: Sun, 6 Sep 2020 14:21:18 +0200
From: Danny Milosavljevic <dannym@HIDDEN>
To: Stefan <stefan-guix@HIDDEN>
Subject: Re: [PATCH] gnu: Handle nfs-root device strings.
Message-ID: <20200906142118.092b702e@HIDDEN>
In-Reply-To: <AF7EB79E-4418-4FBF-8DBD-3EC937ADBC8B@HIDDEN>
References: <AF7EB79E-4418-4FBF-8DBD-3EC937ADBC8B@HIDDEN>
X-Mailer: Claws Mail 3.17.5 (GTK+ 2.24.32; x86_64-unknown-linux-gnu)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="Sig_/1QVgwQ3rZoO3vErRbLTsr=d";
 protocol="application/pgp-signature"; micalg=pgp-sha512
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43219
Cc: Mathieu Othacehe <othacehe@HIDDEN>, 43219 <at> debbugs.gnu.org,
 Maxim Cournoyer <maxim.cournoyer@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--Sig_/1QVgwQ3rZoO3vErRbLTsr=d
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Hello Stefan,

On Sun, 6 Sep 2020 13:52:28 +0200
Stefan <stefan-guix@HIDDEN> wrote:

> I=E2=80=99d like to propose these minimal changes to support an NFS as a =
root file system.

Thanks!

> Currently there are three ways to define the root file system:
>=20
>  =E2=80=A2 (file-system (device (label =E2=80=A6)) =E2=80=A6),=20
>  =E2=80=A2 (file-system (device (union =E2=80=A6)) =E2=80=A6),=20
>  =E2=80=A2 (file-system (device "<string>") =E2=80=A6).
>=20
> The manual does not mention that an NFS is currently not supported as a r=
oot file system. However, NFS mounts are possible already with (file-system=
 (type "nfs") (device "<string>") =E2=80=A6).

Yeah.

> This patch enables users to use an NFS also as a root file system without=
 introducing a new syntax.

That sounds like a good idea.

For the time being, let's just use the string thing for your
functionality--nevermind the <nfs-share> thing for now.

> I was asked before to introduce an <nfs-share> record to achieve the same
>And I did so, see <https://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D41820#2=
0>.
>But due to some other PXE efforts =E2=80=93 for which I don=E2=80=99t see =
progress =E2=80=93 that
>patch got on hold.

First, I like to apologize for the huge delay in handling this stuff.  My
original intent was to let Brice Waegeneire <brice@HIDDEN>, my GSoC in=
tern
for network booting, handle your request--both because he needs it anyway a=
nd
because he presumably has more knowledge on network booting.  He's missing =
in
action (no communication at all) and I gave up having Brice do it.
In any case, his GSoC is over.

I will now look at your request on my own.  I obtained some Raspberry Pis, a
NAS with TFTP server support out of the box and I made sure I could manipul=
ate
the DHCP server I use on my network, so the next step is to try to actually
use your patchset myself--which I didn't do before (sorry).

I want to note that patches with system tests are processed *much* faster--I
don't think many reviewers would go to those lengths I did (obtaining speci=
al
hardware) in order to test contributions--so usually, it would have been
basically stuck forever without system tests.

Thanks for persevering on this feature.

> However, that <nfs-share> record would brake with the compatibility of ho=
w an
>NFS mount is defined today, and it makes the code much more complex without
>having a real gain.

The real gain would be this:

There are a lot of options that one could need (see
https://www.kernel.org/doc/Documentation/filesystems/nfs/nfsroot.txt . They=
 have:

>* <server-ip> (IP address of the NFS server)
>* <root-dir> (name of the directory on the NFS server to mount as /, with =
%s as format string in order to substitute client IP address)
>* <nfs-options>: port (!), rsize, wsize, timeo, retrans, acregmin, acregma=
x, acregmin, acregmax, flags (hard, nointr, noposix, cto, ac).

>ip=3D<client-ip>:<server-ip>:<gw-ip>:<netmask>:<hostname>:<device>:<autoco=
nf>:
>   <dns0-ip>:<dns1-ip>:<ntp0-ip>
>
>  This parameter tells the kernel how to configure IP addresses of devices
>  and also how to set up the IP routing table. It was originally called
>  `nfsaddrs', but now the boot-time IP configuration works independently of
>  NFS, so it was renamed to `ip' and the old name remained as an alias for
>  compatibility reasons.
).

I'm just saying that it will become a record over time anyway.  But maybe
it will be something more general for PXE--hard to tell which is better at
this point in time.   So nevermind for now.

> I think this minimal patch will not conflict with that other PXE effort.
>Its only purpose is to enable the use of an NFS as a root file system alre=
ady today.

Yeah, I agree.

However, I cannot see a patch as attachment to your E-Mail.

--Sig_/1QVgwQ3rZoO3vErRbLTsr=d
Content-Type: application/pgp-signature
Content-Description: OpenPGP digital signature

-----BEGIN PGP SIGNATURE-----

iQEzBAEBCgAdFiEEds7GsXJ0tGXALbPZ5xo1VCwwuqUFAl9U1D4ACgkQ5xo1VCww
uqV0IAf/UuCPClO5bYmVdQvDGz2Si0tfkHiYHEdiHiPOsqpLE+xeTMGCqPj8pQ2Z
g5Z46qg5OLWODf7fmzSMSEd4EbdrWedbFNmeALGgTi2giEynMXy+Xcs0aKTD4izq
eBIN/oej8XpuaZMBC7RMAuhTb8PgAb6WybqcpemJNCUmwA7a35dpyMvp7t7R5Ft0
Ae7XFCp/t+eH8WRbQeUIg6a8TkzbrtLGiP4PNqHmsF9PkVGP/cxr78rvM6/giyuy
fdYQUVrw4YXdwQ8RiZ3YFygA64XvgfCqUbdpnW6vD/SpuNCE0IAz4fGUbjRemP4F
NAqiwphPD2gr2oGPJxQ6YI18n5q0CQ==
=65XK
-----END PGP SIGNATURE-----

--Sig_/1QVgwQ3rZoO3vErRbLTsr=d--




Information forwarded to guix-patches@HIDDEN:
bug#43219; Package guix-patches. Full text available.

Message received at 43219 <at> debbugs.gnu.org:


Received: (at 43219) by debbugs.gnu.org; 6 Sep 2020 11:52:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 06 07:52:43 2020
Received: from localhost ([127.0.0.1]:44924 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kEtDv-00016E-0v
	for submit <at> debbugs.gnu.org; Sun, 06 Sep 2020 07:52:43 -0400
Received: from vsmx012.vodafonemail.xion.oxcs.net ([153.92.174.90]:37200)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stefan-guix@HIDDEN>) id 1kEtDt-000162-NP
 for 43219 <at> debbugs.gnu.org; Sun, 06 Sep 2020 07:52:42 -0400
Received: from vsmx004.vodafonemail.xion.oxcs.net (unknown [192.168.75.198])
 by mta-8-out.mta.xion.oxcs.net (Postfix) with ESMTP id 14FF8F35299;
 Sun,  6 Sep 2020 11:52:36 +0000 (UTC)
Received: from macbook-pro.kuh-wiese.my-router.de (unknown [178.5.77.113])
 by mta-8-out.mta.xion.oxcs.net (Postfix) with ESMTPA id 8C7C319AE50;
 Sun,  6 Sep 2020 11:52:27 +0000 (UTC)
From: Stefan <stefan-guix@HIDDEN>
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
Subject: [PATCH] gnu: Handle nfs-root device strings.
Date: Sun, 6 Sep 2020 13:52:28 +0200
Message-Id: <AF7EB79E-4418-4FBF-8DBD-3EC937ADBC8B@HIDDEN>
To: 43219 <at> debbugs.gnu.org
Mime-Version: 1.0 (Mac OS X Mail 9.3 \(3124\))
X-Mailer: Apple Mail (2.3124)
X-VADE-STATUS: LEGIT
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43219
Cc: Mathieu Othacehe <othacehe@HIDDEN>,
 Maxim Cournoyer <maxim.cournoyer@HIDDEN>,
 Danny Milosavljevic <dannym@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hi!

I=E2=80=99d like to propose these minimal changes to support an NFS as a =
root file system.

Currently there are three ways to define the root file system:

 =E2=80=A2 (file-system (device (label =E2=80=A6)) =E2=80=A6),=20
 =E2=80=A2 (file-system (device (union =E2=80=A6)) =E2=80=A6),=20
 =E2=80=A2 (file-system (device "<string>") =E2=80=A6).

The manual does not mention that an NFS is currently not supported as a =
root file system. However, NFS mounts are possible already with =
(file-system (type "nfs") (device "<string>") =E2=80=A6).

This patch enables users to use an NFS also as a root file system =
without introducing a new syntax.

I was asked before to introduce an <nfs-share> record to achieve the =
same. And I did so, see =
<https://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D41820#20>. But due to =
some other PXE efforts =E2=80=93 for which I don=E2=80=99t see progress =
=E2=80=93 that patch got on hold.

However, that <nfs-share> record would brake with the compatibility of =
how an NFS mount is defined today, and it makes the code much more =
complex without having a real gain.

I think this minimal patch will not conflict with that other PXE effort. =
Its only purpose is to enable the use of an NFS as a root file system =
already today.


Bye

Stefan=




Information forwarded to guix-patches@HIDDEN:
bug#43219; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 5 Sep 2020 11:26:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Sep 05 07:26:38 2020
Received: from localhost ([127.0.0.1]:41631 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kEWL8-0003fm-9I
	for submit <at> debbugs.gnu.org; Sat, 05 Sep 2020 07:26:38 -0400
Received: from lists.gnu.org ([209.51.188.17]:52842)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stefan-guix@HIDDEN>) id 1kEWL6-0003fd-Df
 for submit <at> debbugs.gnu.org; Sat, 05 Sep 2020 07:26:36 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:58438)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <stefan-guix@HIDDEN>)
 id 1kEWL6-0004fs-8A
 for guix-patches@HIDDEN; Sat, 05 Sep 2020 07:26:36 -0400
Received: from vsmx012.vodafonemail.xion.oxcs.net ([153.92.174.90]:17862)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <stefan-guix@HIDDEN>)
 id 1kEWL3-0000ej-Sm
 for guix-patches@HIDDEN; Sat, 05 Sep 2020 07:26:35 -0400
Received: from vsmx004.vodafonemail.xion.oxcs.net (unknown [192.168.75.198])
 by mta-8-out.mta.xion.oxcs.net (Postfix) with ESMTP id 66556F35165
 for <guix-patches@HIDDEN>; Sat,  5 Sep 2020 11:26:29 +0000 (UTC)
Received: from macbook-pro.kuh-wiese.my-router.de (unknown [178.5.77.113])
 by mta-8-out.mta.xion.oxcs.net (Postfix) with ESMTPA id 28A1D19ADD9
 for <guix-patches@HIDDEN>; Sat,  5 Sep 2020 11:26:26 +0000 (UTC)
From: Stefan <stefan-guix@HIDDEN>
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: quoted-printable
Subject: [PATCH] gnu: Handle nfs-root device strings.
Message-Id: <4D0B1280-3FB5-48E5-B985-24773F966618@HIDDEN>
Date: Sat, 5 Sep 2020 13:26:25 +0200
To: guix-patches@HIDDEN
Mime-Version: 1.0 (Mac OS X Mail 9.3 \(3124\))
X-Mailer: Apple Mail (2.3124)
X-VADE-STATUS: LEGIT
Received-SPF: pass client-ip=153.92.174.90;
 envelope-from=stefan-guix@HIDDEN;
 helo=vsmx012.vodafonemail.xion.oxcs.net
X-detected-operating-system: by eggs.gnu.org: First seen = 2020/09/05 07:26:29
X-ACL-Warn: Detected OS   = Linux 2.2.x-3.x (no timestamps) [generic] [fuzzy]
X-Spam_score_int: -25
X-Spam_score: -2.6
X-Spam_bar: --
X-Spam_report: (-2.6 / 5.0 requ) BAYES_00=-1.9, RCVD_IN_DNSWL_LOW=-0.7,
 RCVD_IN_MSPIKE_H3=0.001, RCVD_IN_MSPIKE_WL=0.001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

* gnu/bootloader/grub.scm (grub-root-search): Suppor nfs-root device =
strings to
set the root to tftp.
* gnu/build/file-systems.scm (canonicalize-device-spec): Support =
nfs-root device
strings.
* gnu/build/linux-boot.scm (device-string->file-system-device): Support =
nfs-root
device strings.
* gnu/machine/ssh.scm (machine-check-file-system-availability): Avoid =
checking
of nfs file systems as in guix/scripts/system.scm.
* gnu/system.scm (read-boot-parameters, device-sexp->device): Support =
nfs-root
device strings.

---
gnu/bootloader/grub.scm    |  3 +++
gnu/build/file-systems.scm |  3 ++-
gnu/build/linux-boot.scm   |  5 +++--
gnu/machine/ssh.scm        |  2 ++
gnu/system.scm             | 12 +++++++-----
5 files changed, 17 insertions(+), 8 deletions(-)

diff --git a/gnu/bootloader/grub.scm b/gnu/bootloader/grub.scm
index b905ae360c..b3efcfa1db 100644
--- a/gnu/bootloader/grub.scm
+++ b/gnu/bootloader/grub.scm
@@ -295,6 +295,9 @@ code."
        ((? file-system-label? label)
         (format #f "search --label --set ~a"
                 (file-system-label->string label)))
+        ((? (lambda (device)
+              (and (string? device) (string-contains device ":/"))) =
nfs-uri)
+         "set root=3D(tftp)")
        ((or #f (? string?))
         #~(format #f "search --file --set ~a" #$file)))))

diff --git a/gnu/build/file-systems.scm b/gnu/build/file-systems.scm
index 4ba1503b9f..734d648575 100644
--- a/gnu/build/file-systems.scm
+++ b/gnu/build/file-systems.scm
@@ -675,7 +675,8 @@ were found."
^L
(define (canonicalize-device-spec spec)
  "Return the device name corresponding to SPEC, which can be a <uuid>, =
a
-<file-system-label>, or a string (typically a /dev file name)."
+<file-system-label>, or a string (typically a /dev file name or an =
nfs-root
+containing ':/')."
  (define max-trials
    ;; Number of times we retry partition label resolution, 1 second per
    ;; trial.  Note: somebody reported a delay of 16 seconds (!) before =
their
diff --git a/gnu/build/linux-boot.scm b/gnu/build/linux-boot.scm
index 80fe0cfb9d..32e3536039 100644
--- a/gnu/build/linux-boot.scm
+++ b/gnu/build/linux-boot.scm
@@ -469,9 +469,10 @@ upon error."

  (define (device-string->file-system-device device-string)
    ;; The "--root=3DSPEC" kernel command-line option always provides a
-    ;; string, but the string can represent a device, a UUID, or a
-    ;; label.  So check for all three.
+    ;; string, but the string can represent a device, an nfs-root, a =
UUID, or a
+    ;; label.  So check for all four.
    (cond ((string-prefix? "/" device-string) device-string)
+          ((string-contains device-string ":/") device-string) ; =
nfs-root
          ((uuid device-string) =3D> identity)
          (else (file-system-label device-string))))

diff --git a/gnu/machine/ssh.scm b/gnu/machine/ssh.scm
index 4e31baa4b9..35b42add48 100644
--- a/gnu/machine/ssh.scm
+++ b/gnu/machine/ssh.scm
@@ -172,6 +172,8 @@ exist on the machine."
              (and (file-system-mount? fs)
                   (not (member (file-system-type fs)
                                %pseudo-file-system-types))
+                   ;; Don't try to validate network file systems.
+                   (not (string-prefix? "nfs" (file-system-type fs)))
                   (not (memq 'bind-mount (file-system-flags fs)))))
            (operating-system-file-systems (machine-operating-system =
machine))))

diff --git a/gnu/system.scm b/gnu/system.scm
index f092df56ce..bdb696fe2e 100644
--- a/gnu/system.scm
+++ b/gnu/system.scm
@@ -316,11 +316,13 @@ file system labels."
      ((? bytevector? bv)                         ;old format
       (bytevector->uuid bv 'dce))
      ((? string? device)
-       ;; It used to be that we would not distinguish between labels =
and
-       ;; device names.  Try to infer the right thing here.
-       (if (string-prefix? "/dev/" device)
-           device
-           (file-system-label device)))))
+       (if (string-contains device ":/")
+           device ; nfs-root
+           ;; It used to be that we would not distinguish between =
labels and
+           ;; device names.  Try to infer the right thing here.
+           (if (string-prefix? "/" device)
+               device
+               (file-system-label device))))))

  (match (read port)
    (('boot-parameters ('version 0)
--=20
2.26.0





Acknowledgement sent to Stefan <stefan-guix@HIDDEN>:
New bug report received and forwarded. Copy sent to guix-patches@HIDDEN. Full text available.
Report forwarded to guix-patches@HIDDEN:
bug#43219; Package guix-patches. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 7 Sep 2020 18:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.